#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#ifdef DEBUG
#include <fstream>
std::ifstream fin("test.txt");
#define cin fin
#endif


using namespace std;

int32_t main()
{
	int n, m;
	cin >> n >> m;
	vector<pair<int, int> > events;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		events.push_back({ x, y });
	}
	set<int> w_p;
	map<int, vector<int> > w_fl;
	vector<long long> ans(n);
	long long ct = 0;
	for (int i = 0; i < n;)
	{
		if (w_p.empty())
			ct = events[i].first;
		for (; i < n && events[i].first == ct; i++)
		{
			w_p.insert(i);
			w_fl[events[i].second].push_back(i);
		}
		int cfloor = events[*w_p.begin()].second;
		ct += cfloor - 1;
		for (; i < n && events[i].first <= ct; i++)
		{
			w_p.insert(i);
			w_fl[events[i].second].push_back(i);
		}
		long long ft = ct + cfloor - 1;
		while (w_fl.size() && w_fl.begin()->first <= cfloor)
		{
			for (int p : w_fl.begin()->second)
			{
				ans[p] = ft;
				w_p.erase(p);
			}
			w_fl.erase(w_fl.begin());
		}
		for (; i < n && events[i].first < ft; i++)
			if (cfloor - events[i].second >= events[i].first - ct)
				ans[i] = ft;
			else
			{
				w_p.insert(i);
				w_fl[events[i].second].push_back(i);
			}
		ct = ft;
	}
	for (long long i : ans)
		cout << i << "\n";
	return 0;
}