#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define int int64_t

int sqrt(int x)
{
	int L = 0, R = 1 << 30;

	while (R - L > 1)
	{
		int M = (R + L) / 2;
		if (M * M <= x)
			L = M;
		else
			R = M;
	}
	return L;
}

int sol(int a, int b, int k)
{
	int L = 0, R = 1 << 21;
	while (R - L > 1)
	{
		int M = (R + L) / 2;
		if (M * M * M > b)
			R = M;
		else
			L = M;
	}
	int rb = R;
	L = 0, R = 1 << 21;
	while (R - L > 1)
	{
		int M = (R + L) / 2;
		if (M * M * M >= a)
			R = M;
		else
			L = M;
	}
	int lb = R;
	cerr << lb << " " << rb << "\n";
	int ans = 0;
	for (int i = lb; i < rb; i++)
	{
		assert(i * i * i > 0 && a <= i * i * i && i * i * i <= b);
		int cntl = max(sqrt(max(i * i * i - k - 1, 0ll)), sqrt(a - 1));
		int cntr = min(sqrt(i * i * i + k), sqrt(b));
		//cerr << cntl << " " << cntr << "\n";
		ans += cntr - cntl;
	}
	return ans;
}
/*int32_t main()
{
	int x = 50, y = 100;
	cout <<sol(1e18, 1e18, 0)<< "\n";
	return 0;
}*/

int32_t main()
{
	int a, b, k;
	cin >> a >> b >> k;
	
	cout << sol(a, b, k);
	return 0;
}