#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <map>
#ifdef DEBUG
#include <fstream>
std::ifstream fin("test.txt");
#define cin fin
#else
struct fake_ostream {} fout;
template<class T> fake_ostream& operator << (const fake_ostream& out, const T& val)
{
	return out;
}
#endif

struct cmp
{
	bool operator ()(int a, int b)
	{
		return a > b;
	}
};

using namespace std;

int32_t main()
{
	int n, m;
	cin >> n >> m;
	vector<pair<int, int> > events;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		events.push_back({ x, y });
	}
	priority_queue<int, vector<int>, cmp> w_p;
	map<int, vector<int> > w_fl;
	vector<long long> ans(n, 0);
	long long ct = 0;
	for (int i = 0; i < n || w_p.size();)
	{
		while (w_p.size() && ans[w_p.top()])
			w_p.pop();
		if (w_p.empty())
		{
			if (i == n)
				break;
			ct = events[i].first;
		}
		for (; i < n && events[i].first == ct; i++)
		{
			w_p.push(i);
			w_fl[events[i].second].push_back(i);
		}
		int cfloor = events[w_p.top()].second;
		cerr << cfloor << " " << ct << " -> ";
		ct += cfloor - 1;
		cerr << ct << "\n";
		for (; i < n && events[i].first <= ct; i++)
		{
			w_p.push(i);
			w_fl[events[i].second].push_back(i);
		}
		long long ft = ct + cfloor - 1;
		while (w_fl.size())
		{
			auto it = w_fl.begin();
			if (it->first > cfloor)
				break;
			for (int p : it->second)
			{
				ans[p] = ft;
			}
			w_fl.erase(it);
		}
		for (; i < n && events[i].first < ft; i++)
			if (cfloor - events[i].second >= events[i].first - ct)
				ans[i] = ft;
			else
			{
				w_p.push(i);
				w_fl[events[i].second].push_back(i);
			}
		ct = ft;
	}
	for (long long i : ans)
		cout << i << "\n";
	return 0;
}